/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.internet.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.internet.entity.Praesentationsexport;
import de.ivu.elect.business.internet.entity.PraesentationsexportUK;

public abstract class AbstractPraesentationsexportDAO extends de.ivu.elect.jee.entity.AbstractDAO<Praesentationsexport,
        de.ivu.elect.business.internet.entity.PraesentationsexportPK
    , PraesentationsexportUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractPraesentationsexportDAO.class);

  public AbstractPraesentationsexportDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.internet.entity.PraesentationsexportPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Praesentationsexport findByPrimaryKey(
        de.ivu.elect.business.internet.entity.PraesentationsexportPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Praesentationsexport findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Praesentationsexport.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: ByErgebnisAndPraesentationsexportartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM Praesentationsexport p WHERE p.ergebnis=?1 AND p.praesentationsexportart=?2<br>
      * SQL: <br>
      */
     public Integer deleteByErgebnisAndPraesentationsexportart( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportartCheckedAndAttached =  checkAndAttach(praesentationsexportart, de.ivu.elect.business.ergebnis.entity.Praesentationsexportart.class, "praesentationsexportart"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("PRAESENTATIONSEXPORT.ByErgebnisAndPraesentationsexportart")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, praesentationsexportartCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("deleteByErgebnisAndPraesentationsexportart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Praesentationsexport, deleteByErgebnisAndPraesentationsexportart - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", praesentationsexportart:'"+praesentationsexportart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteByErgebnisAndPraesentationsexportart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ByErgebnisNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT p FROM Praesentationsexport p WHERE p.ergebnis=?1<br>
      * SQL: <br>
      */
     public java.util.List<Praesentationsexport> findByByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PRAESENTATIONSEXPORT.ByErgebnis")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByByErgebnis - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Praesentationsexport, findByByErgebnis - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByByErgebnis(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountErgebnisAndArtenNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(p) FROM Praesentationsexport p WHERE p.ergebnis=?1 AND p.praesentationsexportart=?2 AND p.stimmabgabeart = ?3<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountErgebnisAndArten( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportart,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportartCheckedAndAttached =  checkAndAttach(praesentationsexportart, de.ivu.elect.business.ergebnis.entity.Praesentationsexportart.class, "praesentationsexportart"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeartCheckedAndAttached =  checkAndAttach(stimmabgabeart, de.ivu.elect.business.ergebnis.entity.Stimmabgabeart.class, "stimmabgabeart"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("PRAESENTATIONSEXPORT.CountErgebnisAndArten")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, praesentationsexportartCheckedAndAttached)
                                        .setParameter(3, stimmabgabeartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountErgebnisAndArten - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Praesentationsexport, findByCountErgebnisAndArten - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", praesentationsexportart:'"+praesentationsexportart+"'"
           + ", stimmabgabeart:'"+stimmabgabeart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountErgebnisAndArten(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisAndArtAndAusloeserAndStimmabgabeartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT p FROM Praesentationsexport p WHERE p.ergebnis=?1 AND p.praesentationsexportart = ?2 AND p.praesentationsexportausloeser=?3 AND p.stimmabgabeart = ?4<br>
      * SQL: <br>
      */
     public java.util.List<Praesentationsexport> findByErgebnisAndArtAndAusloeserAndStimmabgabeart( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportart,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser praesentationsexportausloeser,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportartCheckedAndAttached =  checkAndAttach(praesentationsexportart, de.ivu.elect.business.ergebnis.entity.Praesentationsexportart.class, "praesentationsexportart"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser praesentationsexportausloeserCheckedAndAttached =  checkAndAttach(praesentationsexportausloeser, de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser.class, "praesentationsexportausloeser"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeartCheckedAndAttached =  checkAndAttach(stimmabgabeart, de.ivu.elect.business.ergebnis.entity.Stimmabgabeart.class, "stimmabgabeart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PRAESENTATIONSEXPORT.ErgebnisAndArtAndAusloeserAndStimmabgabeart")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, praesentationsexportartCheckedAndAttached)
                                        .setParameter(3, praesentationsexportausloeserCheckedAndAttached)
                                        .setParameter(4, stimmabgabeartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByErgebnisAndArtAndAusloeserAndStimmabgabeart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Praesentationsexport, findByErgebnisAndArtAndAusloeserAndStimmabgabeart - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", praesentationsexportart:'"+praesentationsexportart+"'"
           + ", praesentationsexportausloeser:'"+praesentationsexportausloeser+"'"
           + ", stimmabgabeart:'"+stimmabgabeart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisAndArtAndAusloeserAndStimmabgabeart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisAndArtenNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT p FROM Praesentationsexport p WHERE p.ergebnis=?1 AND p.praesentationsexportart=?2 AND p.stimmabgabeart = ?3<br>
      * SQL: <br>
      */
     public java.util.List<Praesentationsexport> findByErgebnisAndArten( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportart,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportartCheckedAndAttached =  checkAndAttach(praesentationsexportart, de.ivu.elect.business.ergebnis.entity.Praesentationsexportart.class, "praesentationsexportart"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeartCheckedAndAttached =  checkAndAttach(stimmabgabeart, de.ivu.elect.business.ergebnis.entity.Stimmabgabeart.class, "stimmabgabeart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PRAESENTATIONSEXPORT.ErgebnisAndArten")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, praesentationsexportartCheckedAndAttached)
                                        .setParameter(3, stimmabgabeartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByErgebnisAndArten - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Praesentationsexport, findByErgebnisAndArten - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", praesentationsexportart:'"+praesentationsexportart+"'"
           + ", stimmabgabeart:'"+stimmabgabeart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisAndArten(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.internet.entity.PraesentationsexportUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.internet.entity.PraesentationsexportUK uk,
        de.ivu.elect.business.internet.entity.PraesentationsexportPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.internet.entity.Praesentationsexport findByUK(de.ivu.elect.business.internet.entity.PraesentationsexportUK uk){

    try {
     return (de.ivu.elect.business.internet.entity.Praesentationsexport) getEntityManager().createNamedQuery("PRAESENTATIONSEXPORT.UK")
                  .setParameter(1, uk
                .getPraesentationsexportart ()  
              )
             .setParameter(2, uk
                .getPraesentationsexportausloeser ()  
              )
             .setParameter(3, uk
                .getStimmabgabeart ()  
              )
             .setParameter(4, uk
                .getErgebnisUK ()  
                .getErgebnisart ()  
              )
             .setParameter(5, uk
                .getErgebnisUK ()  
                .getName ()  
              )
             .setParameter(6, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(7, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(8, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(9, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(10, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Praesentationsexport, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}